Update Contract - m3ter Documentation

Update Contract

cURL

curl --request PUT \
  --url https://api.m3ter.com/organizations/{orgId}/contracts/{id} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "accountId": "<string>",
  "name": "<string>",
  "startDate": "2023-12-25",
  "endDate": "2023-12-25",
  "version": 123,
  "customFields": {},
  "code": "<string>",
  "description": "<string>",
  "purchaseOrderNumber": "<string>",
  "applyContractPeriodLimits": true,
  "usageFilters": [
    {
      "dimensionCode": "<string>",
      "value": "<string>"
    }
  ],
  "billGroupingKeyId": "<string>"
}
'

Python Code

import requests

url = "https://api.m3ter.com/organizations/{orgId}/contracts/{id}"

payload = {
    "accountId": "<string>",
    "name": "<string>",
    "startDate": "2023-12-25",
    "endDate": "2023-12-25",
    "version": 123,
    "customFields": {},
    "code": "<string>",
    "description": "<string>",
    "purchaseOrderNumber": "<string>",
    "applyContractPeriodLimits": True,
    "usageFilters": [
        {
            "dimensionCode": "<string>",
            "value": "<string>"
        }
    ],
    "billGroupingKeyId": "<string>"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    accountId: '<string>',
    name: '<string>',
    startDate: '2023-12-25',
    endDate: '2023-12-25',
    version: 123,
    customFields: {},
    code: '<string>',
    description: '<string>',
    purchaseOrderNumber: '<string>',
    applyContractPeriodLimits: true,
    usageFilters: [{dimensionCode: '<string>', value: '<string>'}],
    billGroupingKeyId: '<string>'
  })
};

fetch('https://api.m3ter.com/organizations/{orgId}/contracts/{id}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP Code

<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.m3ter.com/organizations/{orgId}/contracts/{id}",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PUT",
  CURLOPT_POSTFIELDS => json_encode([
    'accountId' => '<string>',
    'name' => '<string>',
    'startDate' => '2023-12-25',
    'endDate' => '2023-12-25',
    'version' => 123,
    'customFields' => [],
    'code' => '<string>',
    'description' => '<string>',
    'purchaseOrderNumber' => '<string>',
    'applyContractPeriodLimits' => true,
    'usageFilters' => [[
        'dimensionCode' => '<string>',
        'value' => '<string>'
    ]],
    'billGroupingKeyId' => '<string>'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>

Go Code

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.m3ter.com/organizations/{orgId}/contracts/{id}"

payload := strings.NewReader("{\n  \"accountId\": \"<string>\",\n  \"name\": \"<string>\",\n  \"startDate\": \"2023-12-25\",\n  \"endDate\": \"2023-12-25\",\n  \"version\": 123,\n  \"customFields\": {},\n  \"code\": \"<string>\",\n  \"description\": \"<string>\",\n  \"purchaseOrderNumber\": \"<string>\",\n  \"applyContractPeriodLimits\": true,\n  \"usageFilters\": [\n    {\n      \"dimensionCode\": \"<string>\",\n      \"value\": \"<string>\"\n    }\n  ],\n  \"billGroupingKeyId\": \"<string>\"\n}")

req, _ := http.NewRequest("PUT", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Response

Expected response:

{
  "id": "<string>",
  "version": 123,
  "customFields": {},
  "accountId": "<string>",
  "name": "<string>",
  "code": "<string>",
  "description": "<string>",
  "purchaseOrderNumber": "<string>",
  "applyContractPeriodLimits": true,
  "usageFilters": [
    {
      "dimensionCode": "<string>",
      "value": "<string>"
    }
  ],
  "billGroupingKeyId": "<string>",
  "startDate": "2023-12-25",
  "endDate": "2023-12-25",
  "dtCreated": "2023-11-07T05:31:56Z",
  "dtLastModified": "2023-11-07T05:31:56Z",
  "createdBy": "<string>",
  "lastModifiedBy": "<string>"
}